Index: trunk/LMDZ.MARS/deftank/callphys.def.hdo
===================================================================
--- trunk/LMDZ.MARS/deftank/callphys.def.hdo	(revision 2312)
+++ trunk/LMDZ.MARS/deftank/callphys.def.hdo	(revision 2312)
@@ -0,0 +1,168 @@
+##General options
+##~~~~~~~~~~~~~~~
+#Run with or without tracer transport ?
+tracer=.true.
+
+#Diurnal cycle ?  if diurnal=False, diurnal averaged solar heating
+diurnal=.true.
+
+#Seasonal cycle ? if season=False, Ls stays constant, to value set in "start"
+season = .true.   
+
+#write some more output on the screen ?
+lwrite = .false.    
+
+#Save statistics in file "stats.nc" ?
+callstats =.true.
+
+#Save EOF profiles in file "profiles" for Climate Database?
+calleofdump = .false.
+
+#Directory where external input files are:
+datadir=/data/millour/CO2Clouds/trunk/datadir
+
+## Dust scenario. Used if the dust is prescribed (i.e. if tracer=F or active=F)
+## ~~~~~~~~~~~~~
+#  =1 Dust opt.deph read in startfi; =2 Viking scenario; =3 MGS scenario,
+#  =4 Mars Year 24 from TES assimilation (old version of MY24; dust_tes.nc file)
+#  =6 "cold" (low dust) scenario ; =7 "warm" (high dust) scenario
+#  =8 "climatology" (our best guess of a typical Mars year) scenario
+#  =24 Mars Year 24  ; =25 Mars Year 25 (year with a global dust storm) ; ...
+#  =30 Mars Year 30 
+iaervar = 8
+# Dust opacity at 610 Pa (when constant, i.e. for the iaervar=1 case)
+tauvis=0.2
+# Dust vertical distribution: 
+# (=0: old distrib. (Pollack90), =1: top set by "topdustref",
+#  =2: Viking scenario; =3 MGS scenario)
+iddist  = 3
+# Dust top altitude (km). (Matters only if iddist=1)
+topdustref = 55.
+
+## Physical Parameterizations :
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~
+# call radiative transfer ?
+callrad   = .true.
+# call NLTE radiative schemes ?   matters only if callrad=T
+callnlte = .true.
+# NLTE 15um scheme to use.
+# 0-> Old scheme, static oxygen
+# 1-> Old scheme, dynamic oxygen
+# 2-> New scheme
+nltemodel = 0
+# call CO2 NIR absorption ?   matters only if callrad=T
+callnirco2 = .true.
+# NIR NLTE correction ? matters only if callnirco2=T
+nircorr=0
+# call turbulent vertical diffusion ?
+calldifv  = .true.
+# call convective adjustment ?
+calladj  = .true.
+# Thermals
+calltherm = .true.
+callrichsl = .true.
+# call CO2 condensation ?
+callcond =.true.
+# call thermal conduction in the soil ?
+callsoil = .true.
+# call Lott's gravity wave/subgrid topography scheme ?
+calllott  = .true.
+# Impose polar cap surface albedos as observed by TES?
+TESicealbedo = .true.
+## Coefficient for Northern cap albedoes
+TESice_Ncoef=1.6
+## Coefficient for Southern cap albedoes
+TESice_Scoef=1.6
+
+
+## Radiative transfer options :
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~
+# the rad.transfer is computed every "iradia" physical timestep
+iradia    = 1
+# Output of the exchange coefficient mattrix ? for diagnostic only
+callg2d  = .false.
+# Rayleigh scattering : (should be .false. for now)
+rayleigh  = .false.
+
+## Tracer (dust water, ice and/or chemical species) options (used if tracer=T):
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# DUST: Transported dust ? (if >0, use 'dustbin' dust bins)
+dustbin    = 2
+# DUST: Radiatively active dust ? (matters if dustbin>0)
+active  = .true.
+# DUST: use mass and number mixing ratios to predict dust size ?
+doubleq   = .true.
+# DUST: use a small population of dust particules (submicron dust)?
+submicron = .false.
+# DUST: lifted by GCM surface winds ?
+lifting = .true.
+# DUST: lifted by dust devils ?
+callddevil = .false.
+# DUST: Scavenging by H2O/CO2 snowfall ?
+scavenging = .false.
+# DUST/WATERICE: Gravitationnal sedimentation ?
+sedimentation = .true.
+# WATERICE: Radiatively active transported atmospheric water ice ?
+activice   = .false.
+# WATER: Compute water cycle
+water = .true.
+# WATER: Microphysical scheme for water-ice clouds?
+microphys = .false.
+# WATER: parameter contact
+mteta = 0.95
+# WATER: current permanent caps at both poles. True IS RECOMMENDED
+#        (with .true., North cap is a source of water and South pole
+#         is a cold trap)
+caps  = .true.
+# WATER: Water ice albedo ?
+albedo_h2o_ice = 0.32
+# WATER: Water ice thermal inertia
+inert_h2o_ice = 800
+# WATER: Frost thickness threshold for albedo
+frost_albedo_threshold = 0.005
+# WATER: Effective variance for sedimentation for the log-normal 
+#        distribution of ice particles ?
+nuice_sed=0.1
+# WATER: microphysics is computed "imicro" times per physical timestep
+imicro = 1
+# HDO : computation of HDO cycle
+hdo = .false.
+hdofrac = .true.
+# PHOTOCHEMISTRY: include chemical species 
+photochem  = .false.
+
+# SCATTERERS: set number of scatterers. must be compliant with preceding options.
+naerkind = 1
+
+
+## Thermospheric options (relevant if tracer=T) :
+##~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# call thermosphere ?
+callthermos = .false.
+# WATER: included without cycle (only if water=.false.)
+thermoswater = .false.
+# call thermal conduction ? (only if callthermos=.true.)
+callconduct = .false.
+# call molecular viscosity ? (only if callthermos=.true.)
+callmolvis = .false.
+# call molecular diffusion ? (only if callthermos=.true.)
+callmoldiff = .false.
+# call thermospheric photochemistry ? (only if callthermos=.true.)
+thermochem = .false.
+# call EUV heating ? (only if callthermos=.true.)
+calleuv=.false.
+#Method to include solar variability?
+#0-> Fixed EUV input  1-> Variability with E10.7 as observed
+solvarmod=0
+# fixed E10.7 value (for solvarmod=0)
+# (min=80 , ave=140, max=320)
+fixed_euv_value=140
+#Solar variability as observed for MY? (must be between MY23 and MY32)
+# (only matters if solvarmod=1)
+solvaryear=24
+# value for the UV heating efficiency
+##(experimental values between 0.19 and 0.23, lower values may
+## be used to compensate for low 15 um cooling)
+euveff = 0.21       
+
+